//
//  Linux News Ver.000-7α(2017/03/23)
//  Copyright (C)2017 etokami
//
#include <fstream>
#include <iostream>
#include <random>
#include <string>
#include <vector>
#include <stdio.h>
using namespace std;

//ファイルパスを指定したい場合はここで設定
//末尾に/必須
#define LOGFILE_FILEPATH "./"


//以下変更非推奨
#define LOGFILE_FILENAME "news.dic"        //辞書ファイル名
#define LOGFILE_TEMPNAME "temp.log"        //辞書ファイル再構成用テンポラリファイル名
#define MAXSIZE_TEXT     2048              //本文の半角最大文字数
#define MAXSIZE_OTHER     256              //本文以外の半角最大文字数
#define VERSION_INFO     "0.000-7α"        //バージョン、多分永遠にαのケンちゃんラーメン


//
//  後方のコメント、スペースとタブを削除
//
string remove_space(string str) {

string::size_type a=str.find("//");
if (a != string::npos) { str=str.substr(0,a); }

while (str.back() == ' ' || str.back() == '\t') {
str.pop_back();
}

return str;
}


//
//  乱数取得
//
int get_random(const int &v,const int &w) {

int z=w;
if (v > w) { z=v; }

random_device rnd;
mt19937 mt(rnd());

uniform_int_distribution<int> rndn(v,z);

return rndn(mt);

}


//
//  簡易スプリット処理
//
vector<int> split(const string &str) {

vector<string> buf;
int f=0,v=0;
do {
   string::size_type w=str.find(",",v);
   if (w == string::npos) { w=str.size()-v; f=1; }
   buf.push_back(str.substr(v,w-v));
   v=w+1;
   } while (f == 0);

vector<int> ct;
for (int i=0 ; i<buf.size() ; i++) {
   try { ct.push_back(stoi(buf[i])); }
         catch (...) { ct.push_back(0); }
   }

return ct;

}


//
//  セクション文字列を取得
//
string get_section(int &a) {

vector<string> str = {
   "[text]","[noun]","[place]","[adjective]"
  ,"[na-adjective]","[weather]","[fortune]"
   };

if (a < 0) { a=str.size();
             return ""; }

return str[a];

}


//
//  指定されたセクションを探し直後にシーク
//
bool search(ifstream& inf,const string flag) {
inf.clear();
inf.seekg(0,ios_base::beg);
string str;

while (getline(inf,str)) {

   str=remove_space(str);
   if (str != "") {
        string b = str.substr(0,flag.size());

        if (b == flag) { return true; }
                           }
                      }
return false;
}


//
//  指定されたセクション内の１行をランダムに取得
//
string get_line(ifstream &inf,const int &mode,const int &counter,int &err,const int &page) {

if (counter < 1) { err=40+mode; return ""; }

string buf;
int a=mode;
err=0;
if (search(inf,get_section(a)) == false) { err=20+mode; return ""; }

int v=get_random(1,counter);

if (mode == 0 && page > 0) {
   if (page <= counter) { v=page; }
   }

for (int i=0 ; i!=v ; i++) {
   getline(inf,buf);
   if (inf.eof() || buf[0] == '[') { err=40+mode; return ""; }
   if (buf == "") { i--; }
}

buf=remove_space(buf);

if (mode == 0 && buf.size() > MAXSIZE_TEXT ) { err=60;      return ""; }
if (mode >  0 && buf.size() > MAXSIZE_OTHER) { err=60+mode; return ""; }

return buf;

}


//
//  カラーコード取得
//
string get_colorcode(const int &base,const int &code) {

string str="\033[";
if (code == 0 || code == 7 || code > 9) { str+="39m"; }
                                   else {

   if (base) { str+="3"; }
        else { str+="9"; }

   str+=to_string(code)+"m";
      }

return str;

}


//
//  AAセレクタ(ターミナルでAA表示の実験場)
//
void doll(const int &a,string &str,string &buf,int &b) {

int total=6;  //AA登録時は要変更
int n=a;
if (a < 0) { n=get_random(0,total); }

switch (n) {
case  0: str="      .--.\n     |o_o |\n     |:_/ |\n    //   \\ \\\n   (|     | )\n  /'\\_   _/`\\\n  \\___)=(___/";
         buf="Tux君";
         b=6;
         break;
case  1: str="      ∧ ∧\n     ( ﾟДﾟ)\n     / つつ\n  ～(   ﾉ\n    し'Ｕ";
         buf="ギコ猫のはにゃ～ん";
         b=2;
         break;
case  2: str="  　    /＾>》, -―‐‐＜＾}\n       /::::/,≠´:::::;::ヽ\n      /:::::〃::::／}::丿ハ\n     /:::::i{|::／　ﾉ／}::}\n    /::::::瓜イ ー ´ - ,':ﾉ\n   /:::::::|ﾉﾍ{､  (ﾌ_ノﾉイ\n  /::::::::| ／}｀不')::::";
         buf="ながネギさん";
         b=2;
         break;
case  3: str="    __i＼_／!_\n    ゝ, \"´⌒｀ヽ\n     ﾉ.ノノﾉﾊﾉ〉\n  |＼ﾙﾘ! ﾟヮﾟﾉ!\n  ＼ k_(つ'i(つ\n  ∠ ,く／/ i ゝ\n     ｀!,ﾝｨﾝ\"´";
         buf="(バカ)天才チルノ";
         b=6;
         break;
case  4: str="        ⌒)\n   , '´￣￣｀ 、\n  /, , ,  ,.i､.ヽ\n  L|／x'_ノﾘxﾄ､|｣\n  ,ｱi´┃    ┃  |ﾇ\n  i !､\" ＿_ \",!i\n  ∨ ｎｰ｀-´＜ﾞ乂,\n   {｀i{f⌒iｦ　ﾞ爻、\n   ﾞｰ､∨ 、ﾉ ヽ `ｰ'\n       ＼/   ヽ";
         buf="WindowsMe(嘘)";
         b=4;
         break;
case  5: str="   ／：》ヽ\n  （===○ =）\n  （ づ旦c）\n   《 ＿)_）";
         buf="アッガイ";
         b=1;
         break;
case  6: str="       ,.--  ―――――‐  、\n     ／      ,.-   ―― ｀ヽ\n　  /   |  ／:/: :ｨ:::::::＼\n   /　f⌒ h/':/l:/＼:/l/: :|｀\n  〈＿!l/ﾑl: :/  ＿  '＾jﾉ|\n    ＿| 人_|: l,,￣    =l:|.\n    {:_,::}｣: |   ｢ ７''}!:|_\n   ／　/=､|!: ト  l_/,ィ_└┐:|_\n  （  └勹ﾉi|: |＼､ //'ﾘ 〉＼;／";
         buf="イカちゃん";
         b=6;
         break;
      }
}


//
//  本文作成
//
int make_text(const int &hide,const int &ukagaka,const int &page) {

string str,buf;
int total_section=-1;
buf=get_section(total_section);

ifstream inf (LOGFILE_FILEPATH LOGFILE_FILENAME);
if (! inf) { return 1; }

if (search(inf,"[color]") == false) { return 8; }
getline(inf,str);
vector<int> color=split(str);
if (color.size() != total_section+2) { return 9; }

if (search(inf,"[counter]") == false) { return 2; }

getline(inf,str);
vector<int> ct=split(str);
if (ct.size() != total_section) { return 3; }

int cnt,err,i,v=0,w=0;

str=get_line(inf,0,ct[0],err,page);
if (err != 0) { return err; }

vector<string> code = { "%n","%p","%a","%j","%w","%f" };
do {
   cnt=0;
   for (i=0; i<total_section-1 ; i++) {
      string::size_type p = str.find(code[i]);
      if (p != string::npos) {

      buf=get_line(inf,i+1,ct[i+1],err,0);
      if (err != 0) { return err; }

      str.replace(p,code[i].size(),get_colorcode(color[0],color[i+2])+buf+get_colorcode(color[0],color[1]));
      p=str.find(str,p+buf.size());
      cnt++;
   }
}

string::size_type p=str.find("%r[");
if (p != string::npos) {
   string::size_type q=str.find("]",p);
   if (q == string::npos) { return 4; }
   string buf=str.substr(p,q-p+1);

   buf=buf.substr(3,buf.size()-4);
   if (buf.size() > 9) { return 4; }
   try { v=stoi(buf); }
       catch(...) { return 4; }
   if (v == 0) { return 4; }

   w=get_random(1,v);
   str.replace(p,q-p+1,get_colorcode(color[0],color[8])+to_string(w)+get_colorcode(color[0],color[1]));
   cnt++;
   }
} while (cnt != 0);

string chrbuf;
doll(ukagaka,chrbuf,buf,v);

cout << "- 人工無能" << get_colorcode(color[0],v)+buf+get_colorcode(color[0],0) << "News -" << endl;

if (hide == 0) { cout << chrbuf << endl; }

cout << str << endl;
cout << endl;

return 0;

}


//
//  辞書ファイル作成
//
int make_file() {

ifstream inf (LOGFILE_FILEPATH LOGFILE_FILENAME);
if (! inf.fail()) {
   cout << "既に存在する辞書ファイルを初期化します[y/N]" << endl;
   string s="N";
   cin >> s;
   if (s != "y" && s != "Y") { cout << "中断しました" << endl; return 0; }
}
inf.close();

ofstream otf (LOGFILE_FILEPATH LOGFILE_FILENAME);
if (otf.fail()) { return 5; }

otf
<< "//文字色指定(左から,ベースカラー,基本色,名詞[人名],名詞[地名],形容詞,形容動詞,天気,運勢,乱数)\n"
<< "[color]\n"
<< "0,0,1,2,3,5,6,5,5\n\n"
<< "//辞書ファイル書式\n"
<< "//[text]本文入力(%n/名詞[人名] %p/名詞[地名] %a/形容詞 %j/形容動詞 %w/天気 %r[x]/1-xまでの乱数\n"
<< "//[noun]名詞(人名)\n"
<< "//[place]名詞(地名)\n"
<< "//[adjective]形容詞「美しい」の場合は「美し」と最後の「い」は削ること\n"
<< "//[na-adjective]形容動詞\n"
<< "//[weather]天気\n"
<< "//[fortune]運勢\n"
<< "[counter]\n5,5,5,5,5,5,5\n\n"
<< "[text]\n"
<< "本日%r[12]時頃、%p町で%nさん(%r[100])が%nのようなもので殴られる事件が発生、近隣住民によると被害者は「%jな性格で人に恨まれるとは思えない」と%aそうな表情で語っています。\n"
<< "%n用洗剤の使用法：キャップ%r[10]杯分をスポンジにつけ汚れている%nを%aく拭き取る。%n洗剤と混ざると%jな%nを発生させる恐れがあります。誤って目に入ったり誤飲した場合は%aく%pに相談してください。\n"
<< "%r[31]日%p大学にて講演を行っていた%nOS創始者%n氏がGPUベンダー%n社を非%j的であるとして中指を突き立て「%j！」と名指して非難した件で、同社CEO%n氏は%aく対応に追われているもようです。\n"
<< "明日の天気：%p地方%w時々%w降水確率%r[100]％、%p地方%wのち%w降水確率%r[100]％、所により大量の%nが%aく降ってくる場合があります。\n"
<< "占い師%nの今日の運勢：%n座のあなたは「%f」でラッキーポイント「%r[100]点」、%pで%aい出会いがあるかも？ラッキーアイテムは%n、これを手に%pを散歩すれば%jなことが起こるでしょう。\n\n"
<< "[noun]\n"
<< "ＭＳＸ\nリナックス\nロシア兵\n焼肉定食\nお好み焼き\n\n"
<< "[place]\n"
<< "東京\nニューヨーク\nシベリア\nラーメン屋\nエロマンガ島\n\n"
<< "[adjective]\n"
<< "嬉し\n悲し\n恐ろし\nバカバカし\n恥ずかし\n\n"
<< "[na-adjective]\n"
<< "有名\n悲劇\n静か\n顰蹙\n奇っ怪\n\n"
<< "[weather]\n"
<< "晴れ\n曇り\n雨\n雷雨\n雪\n\n"
<< "[fortune]\n"
<< "大吉\n中吉\n吉\n凶\n大凶"
<< endl;

cout << "辞書ファイルを初期化しました\n" << endl;

}


//
//  辞書ファイルを走査しカウンタ値を再構成します
//
int rebuild_file() {

int total_section=-1,ct[7],c,i;
string cs[7],str,buf;
buf=get_section(total_section);

ifstream inf (LOGFILE_FILEPATH LOGFILE_FILENAME);
if (inf.fail()) { return 1; }

for (int i=0 ; i<total_section ; i++) {
   if (search(inf,get_section(i)) == false) { return 4+i; }
   c=0;
   while (1) {
      getline(inf,str);
      if (inf.eof() || str[0] == '[') { break; }
      if (str != "") { c++; }
   }
   ct[i]=c;
}

for (i=0 ; i<total_section ; i++) { cs[i]=to_string(ct[i]); }

inf.clear();
inf.seekg(0,ios_base::beg);

c=0;
ofstream otf(LOGFILE_FILEPATH LOGFILE_TEMPNAME);
while (1) {
   getline(inf,str);
   if (inf.eof()) { break; }
   if (c == 0) {
      if (str.substr(0,9) == "[counter]") {
      otf << str << endl;
      getline(inf,str);
      str=cs[0];
      for (int j=1 ; j<total_section ; j++) { str+=","+cs[j]; }
      c=1;
      }
   }
otf << str << endl;
}

otf.close();
inf.close();

if (remove(LOGFILE_FILEPATH LOGFILE_FILENAME) == 0) {

   if (rename(LOGFILE_FILEPATH LOGFILE_TEMPNAME , LOGFILE_FILEPATH LOGFILE_FILENAME) == 0) {
      cout << "辞書ファイルを再構成しました\n" << endl;
      return 0;
      } else { return 6; }

   } else { return 7; }

}


//
//  ヘルプ表示
//
void help(int a) {

cout
<< "人工無能Tux君ニュース Version " << VERSION_INFO << "\n"
<< "使用法:linux_news... ニュースを表示\n"
<< "または:linux_news --make ....... 辞書ファイル作成\n"
<< "または:linux_news --rebuild .... 辞書ファイル再構成\n"
<< "または:linux_news --hide ....... AA非表示\n"
<< "または:linux_news --page n ..... 任意の本文に固定\n"
<< "または:linux_news --help / -h .. ヘルプ表示\n"
<< endl;

if (a == 0) { return; }

cout
<< "または:linux_news --kakushi .... 隠しヘルプ\n"
<< "または:linux_news --giko ....... ギコ猫のはにゃ～んニュース\n"
<< "または:linux_news --negi ....... ながネギさんニュース\n"
<< "または:linux_news --baka ....... チルノの(９)ニュース\n"
<< "または:linux_news --blue ....... WindowsMe(嘘)ニュース\n"
<< "または:linux_news --zaku ....... アッガイニュース\n"
<< "または:linux_news --ika ........ イカちゃんニュース\n"
<< "または:linux_news --nini ....... AAをランダム選択\n"
<< endl;

}


//
//  オプションの有無をチェック
//
int check_option(int *argc,char *argv[],string sample) {

if (*argc == 1) { return 0; }

for (int i=1 ; i<*argc ; i++) {
   string s=argv[i];
   if (s == sample) { return i; }
}
return 0;

}


//
//  メイン処理
//
int main(int argc,char *argv[]) {

int hide=0;    //AA隠し用
int ukagaka=0;  //AA選択用
int page=0;    //強制本文選択

if (argc > 1) {
   int op,om;
   if (check_option(&argc,argv,"--make")) { make_file();
                                            return 0; }
   if (check_option(&argc,argv,"--rebuild")) { rebuild_file();
                                               return 0; }
   if (check_option(&argc,argv,"--hide")) { hide=1; }
   if (check_option(&argc,argv,"--help")) { help(0);
                                            return 0; }
   if (check_option(&argc,argv,"-h")) { help(0);
                                        return 0; }
   if (check_option(&argc,argv,"--kakushi")) { help(1);
                                               return 0; }
   if (check_option(&argc,argv,"--giko")) { ukagaka=1; }
   if (check_option(&argc,argv,"--negi")) { ukagaka=2; }
   if (check_option(&argc,argv,"--baka")) { ukagaka=3; }
   if (check_option(&argc,argv,"--blue")) { ukagaka=4; }
   if (check_option(&argc,argv,"--zaku")) { ukagaka=5; }
   if (check_option(&argc,argv,"--ika" )) { ukagaka=6; }
   if (check_option(&argc,argv,"--nini")) { ukagaka=-1; }
   if (op=check_option(&argc,argv,"--page")) {
      if (op+1 < argc) {
      try { om=stoi(argv[op+1]);
            page=om; }
      catch (...) { page=0; }
      if (page < 0) { page=0; }
   }
   }
}

int a=make_text(hide,ukagaka,page);

//以下エラー処理
if (a != 0) {

string b,c="";

switch (a) {
case  1: b="辞書ファイルが見つかりません";
         c="--makeオプションで辞書ファイルを作成できます";
         break;
case  2: b="[counter] / セクションが見つかりません";
         break;
case  3: b="[counter] / カウンタ値が不正です";
         c="--rebuildオプションで復旧できるかもしれません";
         break;
case  4: b="[text] / 乱数の書式に異常があります";
         c="%rに続く[]がで閉じられていない、10桁以上の数値、数字以外の文字等の確認をしてください";
         break;
case  5: b="辞書ファイルの作成に失敗しました";
         break;
case  6: b="辞書ファイル化に失敗しました";
         c="手動でtemp.logをnews.dicにリネームすることで修復できるかもしれません";
         break;
case  7: b="一時ファイルの作成に失敗しました";
         break;
case  8: b="[color] / セクションが見つかりません";
         break;
case  9: b="[color] / 色情報が不正です";
         break;
case 20: b="[text] / セクションが見つかりません";
         break;
case 21: b="[noun] / セクションが見つかりません";
         break;
case 22: b="[adjective] / セクションが見つかりません";
         break;
case 23: b="[na-adjective] / セクションが見つかりません";
         break;
case 24: b="[weather] / セクションが見つかりません";
         break;
case 25: b="[fortune] / セクションが見つかりません";
         break;
case 40: b="[text] / 書式に異常な項目があります";
         break;
case 41: b="[noun] / 書式に異常な項目があります";
         break;
case 42: b="[adjective] / 書式に異常な項目があります";
         break;
case 43: b="[na-adjective] / 書式に異常な項目があります";
         break;
case 44: b="[weather] / 書式に異常な項目があります";
         break;
case 45: b="[fortune] / 書式に異常な項目があります";
         break;
case 60: b="[text] / 本文が長過ぎる項目があります";
         break;
case 61: b="[noun] / 名詞(人名)が長すぎる項目があります";
         break;
case 62: b="[place] / 名詞(地名)が長すぎる項目があります";
         break;
case 63: b="[adjective] / 形容詞に長過ぎる項目があります";
         break;
case 64: b="[na-adjective] / 形容動詞に長過ぎる項目があります";
         break;
case 65: b="[weather] / 天候に長過ぎる項目があります";
         break;
case 66: b="[fortune] / 占いに長過ぎる項目があります";
         break;
}

cout << "ERROR: " << b << endl;
if (c != "") { cout << "Tips : " << c << endl; }
cout << endl;

}

}
